//Vodiace čiary na začiatku a konci sadzobného obrazca podľa zarážky odseku
//a záhlavie, zápätie
//
//(c) JP, verzia 2015.01.27
//
//Globálne premenné
var gZarazkyOdseku=12;
var gVyskaZahlavia=12;
var gOdsadenieZahlavia=6;
var gVyskaZapatia=12;
var gOdsadenieZapatia=24;

if (app.documents.length != 0){
 if (app.selection.length > 0){
  switch(app.selection[0].constructor.name){
   case "Rectangle":
   case "Oval":
   case "Polygon":
   case "GraphicLine":
   case "Group":
   case "TextFrame":
   case "Button":
    ZobrazDialog();
    break;
   default:
    alert("Prosím vyberte objekt a skúste to znova.");
    break;
  }
 }
 else{
  alert("Prosím vyberte objekt a skúste to znova.");
 }
}
else{
 alert("Prosím otvorte dokument, vyberte objekt, a skúste to znova.");
}
 
function ZobrazDialog(){
 var Dokument=app.activeDocument;
 //Odpamätanie pôvodných nastavení
 var PovodneNastavenia=Dokument.viewPreferences.rulerOrigin;
 var PovodnaXJednotka=Dokument.viewPreferences.horizontalMeasurementUnits;
 var PovodnaYJednotka=Dokument.viewPreferences.verticalMeasurementUnits;
 var PovodnaTahJednotka=app.viewPreferences.strokeMeasurementUnits;
 //Nastavenie jednotiek na pt
 Dokument.viewPreferences.rulerOrigin=RulerOrigin.spreadOrigin;
 Dokument.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.strokeMeasurementUnits=MeasurementUnits.POINTS;
 //Počiatočné nastavenia podľa mriežky účiaria
 var MriezkaUciaria=Dokument.gridPreferences.baselineDivision;
 gZarazkyOdseku=MriezkaUciaria;
 gVyskaZahlavia=MriezkaUciaria;
 gOdsadenieZahlavia=MriezkaUciaria/2;
 gVyskaZapatia=MriezkaUciaria;
 gOdsadenieZapatia=MriezkaUciaria*2;
 //Načítame nastavenia zo súboru (ak existuje)
 Nacitaj_nastavenia();
 var DialogMoznosti=app.dialogs.add({name:"Vodiace čiary zarážok odsekov, záhlavie, zápätie"});
 with(DialogMoznosti){
  with(dialogColumns.add()){
   with(borderPanels.add()){
    with (dialogColumns.add()){
     staticTexts.add({staticLabel:"Odseková zarážka:"});
     staticTexts.add({staticLabel:" "});
     staticTexts.add({staticLabel:"Výška záhlavia:"});
     staticTexts.add({staticLabel:"Odsadenie záhlavia:"});
     staticTexts.add({staticLabel:"Výška zápätia:"});
     staticTexts.add({staticLabel:"Odsadenie zápätia:"});
    }
    with (dialogColumns.add()){    
     //Veľkosť zarážky predpokladáme vo veľkosti mriežky účiaria
     var OdsekovaZarazkaField=measurementEditboxes.add({editValue:gZarazkyOdseku, editUnits:MeasurementUnits.POINTS});
     staticTexts.add({staticLabel:" "});
     var VyskaZahlaviaField=measurementEditboxes.add({editValue:gVyskaZahlavia, editUnits:MeasurementUnits.POINTS});
     var OdsadenieZahlaviaField=measurementEditboxes.add({editValue:gOdsadenieZahlavia, editUnits:MeasurementUnits.POINTS});
     var VyskaZapatiaField=measurementEditboxes.add({editValue:gVyskaZapatia, editUnits:MeasurementUnits.POINTS});
     var OdsadenieZapatiaField=measurementEditboxes.add({editValue:gOdsadenieZapatia, editUnits:MeasurementUnits.POINTS});
    }
   }
  }
 }
 var aBodyNaPalec=app.activeDocument.viewPreferences.pointsPerInch; // Odpamätáme si terajšie nastavenie bodov na palec
 try
 {
  app.activeDocument.viewPreferences.pointsPerInch=72; // nastavíme americký systém 72 bodov na palec
 }
 catch (e)
 { 
  app.viewPreferences.pointsPerInch=72;
 }
 var DialogMoznostiOK=DialogMoznosti.show();
 //Nastavenie premenných z dialógu
 gZarazkyOdseku=OdsekovaZarazkaField.editValue;
 gVyskaZahlavia=VyskaZahlaviaField.editValue;
 gOdsadenieZahlavia=OdsadenieZahlaviaField.editValue;
 gVyskaZapatia=VyskaZapatiaField.editValue;
 gOdsadenieZapatia=OdsadenieZapatiaField.editValue;
 //Nastavenie povodnych hodnot
  try
 {
  app.activeDocument.viewPreferences.pointsPerInch=aBodyNaPalec; // nastavíme používateľský systém bodov na palec
 }
 catch (e)
 {
  app.viewPreferences.pointsPerInch=aBodyNaPalec;
 }
 Dokument.viewPreferences.rulerOrigin=PovodneNastavenia;
 Dokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 Dokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
 Dokument.viewPreferences.strokeMeasurementUnits=PovodnaTahJednotka;
 if (DialogMoznostiOK == true){
  DialogMoznosti.destroy();
  Uloz_nastavenia();
  KresliOrezoveZnacky();
 }
 else{
  DialogMoznosti.destroy();
 }
}

function KresliOrezoveZnacky(){
 var Okraje, Objekt;
 var Dokument=app.activeDocument;
 //Odpamätanie pôvodných nastavení
 var PovodneNastavenia=Dokument.viewPreferences.rulerOrigin;
 var PovodnaXJednotka=Dokument.viewPreferences.horizontalMeasurementUnits;
 var PovodnaYJednotka=Dokument.viewPreferences.verticalMeasurementUnits;
 var PovodnaTahJednotka=app.viewPreferences.strokeMeasurementUnits;
 //Nastavenie jednotiek na pt
 Dokument.viewPreferences.rulerOrigin=RulerOrigin.spreadOrigin;
 Dokument.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.strokeMeasurementUnits=MeasurementUnits.POINTS;
 //Vytvorenie vrstvy pre vodiace čiary (ak neexistuje)
 var VrstvaZarazkyOdseku=Dokument.layers.item("ZarazkyOdsekov");
 try{
  VrstvaZarazkyOdsekuName=VrstvaZarazkyOdseku.name;
 }
 catch (Chyba){
  var VrstvaZarazkyOdseku=Dokument.layers.add({name:"ZarazkyOdsekov"});
 }
 //Pre všetky vybrané objekty
 Okraje=Dokument.selection[0].visibleBounds;
 var VzorovaStranka=Dokument.masterSpreads.item(0);
 var NovyRamec;
 for(var KtoryObjekt=0; KtoryObjekt < Dokument.selection.length; KtoryObjekt ++){
  Objekt=Dokument.selection[KtoryObjekt];
  Okraje=Objekt.visibleBounds;
  if (gZarazkyOdseku != 0) {
   //Vykreslenie vodiacich čiar
   //Zvislé čiary (Orientacia=1)
   var LaveX=Okraje[1]+gZarazkyOdseku;
   var PraveX=Okraje[3]-gZarazkyOdseku;
   KresliVodiacuCiaru(LaveX, 1, VrstvaZarazkyOdseku);
   KresliVodiacuCiaru(PraveX, 1, VrstvaZarazkyOdseku);
  }
  Dokument.activeLayer=Dokument.layers.item(1);
  if (gVyskaZahlavia != 0) {
   NovyRamec=VzorovaStranka.textFrames.add();
   NovyRamec.geometricBounds=[Okraje[0]-gOdsadenieZahlavia-gVyskaZahlavia, Okraje[1], Okraje[0]-gOdsadenieZahlavia, Okraje[3]];
  }
  if (gVyskaZapatia != 0) {
   NovyRamec=VzorovaStranka.textFrames.add();
   NovyRamec.geometricBounds=[Okraje[2]+gOdsadenieZapatia, Okraje[1], Okraje[2]+gOdsadenieZapatia+gVyskaZapatia, Okraje[3]];
  }  
 }
 //Nastavenie povodnych hodnot
 Dokument.viewPreferences.rulerOrigin=PovodneNastavenia;
 Dokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 Dokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
 Dokument.viewPreferences.strokeMeasurementUnits=PovodnaTahJednotka;
}

function KresliVodiacuCiaru(Suradnica, Orientacia, VrstvaZarazkyOdseku){
 with(app.activeWindow.activeSpread){
  if(Orientacia == 0){
   with (guides.add(VrstvaZarazkyOdseku, undefined, undefined)){
    orientation=HorizontalOrVertical.horizontal;
    location=Suradnica;
   }
  }
  else{
   with (guides.add(VrstvaZarazkyOdseku, undefined, undefined)){
    orientation=HorizontalOrVertical.vertical;
    location=Suradnica;
   }
  }
 }
}

function Nacitaj_nastavenia(){
 //Načítanie posledných nastavení zo súboru
 var SuborSkriptu=File(app.activeScript);
 var AdresarSkriptu=SuborSkriptu.parent;
 var NazovSuboru=AdresarSkriptu + "/" + "ZahlavieZapatie_nastavenia.txt";
 var Subor=File(NazovSuboru);
 var OtvorenySubor=Subor.open("r", undefined, undefined);
 if (OtvorenySubor) {
  var PoleNastaveni=Subor.read();
  PoleNastaveni=PoleNastaveni.split("\n");
  if (PoleNastaveni.length == 6) {
   gZarazkyOdseku=+(PoleNastaveni[0] + "");
   gVyskaZahlavia=+(PoleNastaveni[1] + "");
   gOdsadenieZahlavia=+(PoleNastaveni[2] + "");
   gVyskaZapatia=+(PoleNastaveni[3] + "");
   gOdsadenieZapatia=+(PoleNastaveni[4] + "");  
  }
 }
 Subor.close();
}

function Uloz_nastavenia(){
 //Uloženie posledných nastavení do súboru
 var SuborSkriptu=File(app.activeScript);
 var AdresarSkriptu=SuborSkriptu.parent;
 var NazovSuboru=AdresarSkriptu + "/" + "ZahlavieZapatie_nastavenia.txt";
 var Subor=File(NazovSuboru);
 var OtvorenySubor=Subor.open("w", undefined, undefined);
 if (OtvorenySubor) {
  Subor.writeln(gZarazkyOdseku);
  Subor.writeln(gVyskaZahlavia);
  Subor.writeln(gOdsadenieZahlavia);
  Subor.writeln(gVyskaZapatia);
  Subor.writeln(gOdsadenieZapatia);
 }
 Subor.close();
}
